install <- function(){
#    require(reposTools)
    cat("\ninstalling all Bioconductor 2.0 packages!\n")
    source("http://www.bioconductor.org/getBioC.R")
    pkgs <- read.table("Rweb_packages.txt",sep="\t",as.is=TRUE)[,1]
    getBioC(pkgs)
    cat("Checkinp proper installation of packages:\n")
    checkInstall(pkgs)
    cat("\nok\n")
    metapkgs <- read.table("chips.txt",sep="\t",as.is=TRUE)[,1]
    cat("Installing annotation and metadata packages.\nThis can take several minutes.\nOnly a subset of available annotation packages are installed. Check the bioconductor homepage for a list of available metadata packages.")
    metapkgs <- c(metapkgs,paste(metapkgs,"cdf",sep=""),paste(metapkgs,"probe",sep=""))
    getBioC(metapkgs)
    cat("\nFinished installing metadata packages.\n")
    cat("Checkinp proper installation of metadata packages:\n")
    checkInstall(metapkgs)
    cat("\nok\n")
    cat("Installation of all packages finished successfully, congratulations.\n")
    cat("checking if packages Rgraphviz and RBGL packages were installed successfully...\n")
    cat("checking for graph: ...")
    if(!require(graph,quietly=TRUE)){stop("\nERROR: library graph not installed! install graph package manually!\n")}
    cat("ok\nchecking for Rgraphviz: ...")
    if(!require(Rgraphviz,quietly=TRUE)){stop("\nERROR: library Rgraphviz not installed! install Rgraphviz package manually!\n")}
    cat("ok\nchecking for RBGL: ...")
    if(!require(RBGL,quietly=TRUE)){stop("\nERROR: library RBGL not installed! install RBGL package manually!\n")}
    cat("\n")
}

checkInstall <- function(p,String){
	if(!require(maDB,quietly=TRUE)){stop("\nERROR: library maDB not installed! Try installing maDB package manually from source.\n")}
	for(i in 1:length(p)){
		if(!require(p[i],character.only=TRUE,quietly=TRUE)){stop(paste("\nERROR: library",p[i],"is not installed! Try to install it manually.\n"))}
		progress( (i/length(p))*100 ,steps=40)
	}
}

